<?php
/*
RSS to Twitter v0.1
by paul stamatiou
of http://paulstamatiou.com
based on code from
http://morethanseven.net/posts/posting-to-twitter-using-php

Tweaked by david linsin
of http://dlinsin.blogspot.com
*/
include('parse.php');

$status = getCurrentStatus();
if (updateNecessary($status)) {
 $twitter_url = 'http://twitter.com/statuses/update.xml';
 $buffer = doCurl($twitter_url,"status=" . $status, "");
 if (empty($buffer)){
  echo '<br/>no message to update';
 } else {
  echo '<br/>success';
 }
} else {
 echo 'no update necessary';
}

function updateNecessary($currentStatus) {
	$twitter_url = 'http://twitter.com/statuses/user_timeline.rss';
	$buffer = doCurl($twitter_url, "", "count=1");

	$rss = new lastRSS;
	if ($rs = $rss->parseContent($buffer)){
		$oldStatus = substr($rs[items][0][title], (strpos($rs[items][0][title], "David Linsin: ")+strlen("David Linsin: ")));
	} else { die('could not parse old status'); }

	if (trim($oldStatus) == trim($currentStatus)) {
	  echo "current&old: " . $oldStatus . "<br/>";
	  return false;
	} else {
	  echo "current/old: " . $currentStatus . " / " .  $oldStatus . "<br/>";
	  return true;
	}
}

function doCurl($twitter_url, $param1, $param2) {
    $params = "";
    if ($param1 != "") {
     $params = $params . $param1;
    }
    if ($param2 != "" && $params != "") {
     $params = $params . "&" . $param2;
    } else if ($param2 != "" && $params == "") {
     $params = $params . $param2;
    }

	$curl_handle = curl_init();
	curl_setopt($curl_handle,CURLOPT_URL,"$twitter_url");
	curl_setopt($curl_handle,CURLOPT_CONNECTTIMEOUT,2);
	curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($curl_handle,CURLOPT_POST,1);
	curl_setopt($curl_handle,CURLOPT_POSTFIELDS, $params);
	curl_setopt($curl_handle,CURLOPT_USERPWD,"dlinsin:yourPW");
	$buffer = curl_exec($curl_handle);
	curl_close($curl_handle);
	return $buffer;
}

function getCurrentStatus() {
	$feed = "http://pipes.yahoo.com/pipes/pipe.run?_id=YG8uiJQW3BGl34T41fC6Jw&_render=rss"; //the feed you want to micro-syndicate
	$rss = new lastRSS;
	if ($rs = $rss->get($feed)){
	    $title = $rs[items][0][title];
	    $title = 'at' . substr($title, (strpos($title,'called')+6));
		$url = $rs[items][0][link];
	} else { die('Error: RSS file not found, dude.'); }
	$tiny_url =  file_get_contents("http://tinyurl.com/api-create.php?url=" . $url);
    $status = $title . " " . $tiny_url;
    return $status;
}

?>